(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                 A Functional Constraint Library                     *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, CENA               *)
(*                                                                     *)
(* Copyright 2001 CENA. All rights reserved. This file is distributed  *)
(* under the terms of the GNU Lesser General Public License.           *)
(***********************************************************************)
(* $Id: fcl_alldiff.mli,v 1.12 2001/06/20 15:30:17 barnier Exp $ *)

(* Module [Alldiff]: the "All Different" Constraint  *)

type algo = Lazy | Bin_matching of Fcl_var.Attr.event
val cstr : ?algo:algo -> Fcl_var.Fd.t array -> Fcl_cstr.t
(* [alldiff (?algo:Lazy) vars] States that variables of [vars] are different
   from each other. The optional argument [algo] specifies the level of
   propagation.
   [Lazy]: waits for instantiation and removes from other domains.
   [Bin_matching c]: waits for event [c] (e.g. [Var.Attr.on_refine])
   and uses a bin matching algorithm to ensure the constraint is
   consistent. [algo] default value is [Lazy].
   Not reifiable. *)
